#include <openssl/bio.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>

#include "netex.h"
#include "config.h"

#define PORT_NUM_LENGHT 6


void netex_init(void)
{
    // OpenSSL
    PRINT_LINE("Initializing OpenSSL...");
    SSL_load_error_strings();
    SSL_library_init();
    OpenSSL_add_all_algorithms();
}
void netex_shutdown(void)
{
    // OpenSSL
    ERR_free_strings();
    EVP_cleanup();
}

int setup_socket(const int port, const char* hostname)
{
    struct sockaddr_in sockaddr_in;
    const int sock_fd = socket(AF_INET, SOCK_STREAM, 0);
    if (sock_fd < 0)
    {
        ERROR("Failed to created socket");
        return -1;
    }
    sockaddr_in.sin_family = AF_INET;
    sockaddr_in.sin_port = htons(port);
    sockaddr_in.sin_addr.s_addr = inet_addr(hostname);
    const int bind_result = bind(sock_fd, (struct sockaddr*)&sockaddr_in, sizeof(sockaddr_in));
    if (bind_result != 0)
    {
        ERROR("Could not bind!");
        close(sock_fd);
        return -1;
    }
    return sock_fd;
}